<?php


require_once('wp-updates-theme.php');
new WPUpdatesThemeUpdater_705( 'http://wp-updates.com/api/2/theme', basename( get_template_directory() ) );

// Identify the theme for all functions

	$themename = "MixMag Theme";
	$shortname = "mediafap";




// Create the initial theme options function

function mytheme_add_admin() {
	global $themename, $shortname, $options;
	$optionvar = array();
		if ( isset($_GET['page']) && $_GET['page'] == basename(__FILE__) )  {
			if ( isset($_REQUEST['action']) && 'save' == $_REQUEST['action'] ) {
				foreach ($options as $value) {
					update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }
					foreach ($options as $value) {
						if( isset( $_REQUEST[ $value['id'] ] ) ) {
							$optionvar[$value['id']] = $_REQUEST[ $value['id']];
						} else {
							$optionvar[$value['id']] = null;
						}
					}
				update_option( $shortname."_options", $optionvar  );
				header("Location: themes.php?page=functions.php&saved=true");
				die;
			} else if( isset($_REQUEST['action']) && 'reset' == $_REQUEST['action'] ) {
				foreach ($options as $value) {
					delete_option( $value['id'] ); }
				header("Location: themes.php?page=functions.php&reset=true");
				die;
			}
		}
	add_theme_page("Options", "Mix Mag Options", 'edit_themes', basename(__FILE__), 'mytheme_admin');
}




// Create the plugin auto-installer

require_once dirname( __FILE__ ) . '/class/class-tgm-plugin-activation.php';

add_action( 'tgmpa_register', 'my_theme_register_required_plugins' );

function my_theme_register_required_plugins() {


	$plugins = array(

		array(
			'name'     				=> 'WP Days Ago', // The plugin name
			'slug'     				=> 'wp-days-ago', // The plugin slug (typically the folder name)
			'source'   				=> get_stylesheet_directory() . '/lib/wp-days-ago.zip', // The plugin source
			'required' 				=> false, // If false, the plugin is only 'recommended' instead of required
			'version' 				=> '', // E.g. 1.0.0. If set, the active plugin must be this version or higher, otherwise a notice is presented
			'force_activation' 		=> false, // If true, plugin is activated upon theme activation and cannot be deactivated until theme switch
			'force_deactivation' 	=> false, // If true, plugin is deactivated upon theme switch, useful for theme-specific plugins
			'external_url' 			=> '', // If set, overrides default API URL and points to an external URL
		),
		array(
			'name'     				=> 'Mingle Forum', // The plugin name
			'slug'     				=> 'mingle-forum', // The plugin slug (typically the folder name)
			'source'   				=> get_stylesheet_directory() . '/lib/mingle-forum.zip', // The plugin source
			'required' 				=> false, // If false, the plugin is only 'recommended' instead of required
			'version' 				=> '', // E.g. 1.0.0. If set, the active plugin must be this version or higher, otherwise a notice is presented
			'force_activation' 		=> false, // If true, plugin is activated upon theme activation and cannot be deactivated until theme switch
			'force_deactivation' 	=> false, // If true, plugin is deactivated upon theme switch, useful for theme-specific plugins
			'external_url' 			=> '', // If set, overrides default API URL and points to an external URL
		),

	);


	$theme_text_domain = 'mediafap';


	$config = array(
		'domain'       		=> $theme_text_domain,         	// Text domain - likely want to be the same as your theme.
		'default_path' 		=> '',                         	// Default absolute path to pre-packaged plugins
		'parent_menu_slug' 	=> 'themes.php', 				// Default parent menu slug
		'parent_url_slug' 	=> 'themes.php', 				// Default parent URL slug
		'menu'         		=> 'install-required-plugins', 	// Menu slug
		'has_notices'      	=> true,                       	// Show admin notices or not
		'is_automatic'    	=> false,					   	// Automatically activate plugins after installation or not
		'message' 			=> '',							// Message to output right before the plugins table
		'strings'      		=> array(
			'page_title'                       			=> __( 'Install Required Plugins', $theme_text_domain ),
			'menu_title'                       			=> __( 'Install Plugins', $theme_text_domain ),
			'installing'                       			=> __( 'Installing Plugin: %s', $theme_text_domain ), // %1$s = plugin name
			'oops'                             			=> __( 'Something went wrong with the plugin API.', $theme_text_domain ),
			'notice_can_install_required'     			=> _n_noop( 'This theme requires the following plugin: %1$s.', 'This theme requires the following plugins: %1$s.' ), // %1$s = plugin name(s)
			'notice_can_install_recommended'			=> _n_noop( 'This theme recommends the following plugin: %1$s.', 'This theme recommends the following plugins: %1$s.' ), // %1$s = plugin name(s)
			'notice_cannot_install'  					=> _n_noop( 'Sorry, but you do not have the correct permissions to install the %s plugin. Contact the administrator of this site for help on getting the plugin installed.', 'Sorry, but you do not have the correct permissions to install the %s plugins. Contact the administrator of this site for help on getting the plugins installed.' ), // %1$s = plugin name(s)
			'notice_can_activate_required'    			=> _n_noop( 'The following required plugin is currently inactive: %1$s.', 'The following required plugins are currently inactive: %1$s.' ), // %1$s = plugin name(s)
			'notice_can_activate_recommended'			=> _n_noop( 'The following recommended plugin is currently inactive: %1$s.', 'The following recommended plugins are currently inactive: %1$s.' ), // %1$s = plugin name(s)
			'notice_cannot_activate' 					=> _n_noop( 'Sorry, but you do not have the correct permissions to activate the %s plugin. Contact the administrator of this site for help on getting the plugin activated.', 'Sorry, but you do not have the correct permissions to activate the %s plugins. Contact the administrator of this site for help on getting the plugins activated.' ), // %1$s = plugin name(s)
			'notice_ask_to_update' 						=> _n_noop( 'The following plugin needs to be updated to its latest version to ensure maximum compatibility with this theme: %1$s.', 'The following plugins need to be updated to their latest version to ensure maximum compatibility with this theme: %1$s.' ), // %1$s = plugin name(s)
			'notice_cannot_update' 						=> _n_noop( 'Sorry, but you do not have the correct permissions to update the %s plugin. Contact the administrator of this site for help on getting the plugin updated.', 'Sorry, but you do not have the correct permissions to update the %s plugins. Contact the administrator of this site for help on getting the plugins updated.' ), // %1$s = plugin name(s)
			'install_link' 					  			=> _n_noop( 'Begin installing plugin', 'Begin installing plugins' ),
			'activate_link' 				  			=> _n_noop( 'Activate installed plugin', 'Activate installed plugins' ),
			'return'                           			=> __( 'Return to Required Plugins Installer', $theme_text_domain ),
			'plugin_activated'                 			=> __( 'Plugin activated successfully.', $theme_text_domain ),
			'complete' 									=> __( 'All plugins installed and activated successfully. %s', $theme_text_domain ), // %1$s = dashboard link
			'nag_type'									=> 'updated' // Determines admin notice type - can only be 'updated' or 'error'
		)
	);

	tgmpa( $plugins, $config );

}





// Get current user role

function get_user_role() {
	global $current_user;

	$user_roles = $current_user->roles;
	$user_role = array_shift($user_roles);

	return $user_role;
}




// Get current user published post count

function postCount() {
    global $wpdb, $current_user;
    get_currentuserinfo();
    $userId = $current_user->ID;
$query = "SELECT COUNT(*) FROM $wpdb->posts ";
        $where = "WHERE post_type='post' AND post_status='publish' AND post_author='$userId'";
        $count = $wpdb->get_var($query . $where);
		echo $count;
}




// Get current user pending post count

function pendingCount() {
    global $wpdb, $current_user;
    get_currentuserinfo();
    $userId = $current_user->ID;
$query = "SELECT COUNT(*) FROM $wpdb->posts ";
        $where = "WHERE post_type='post' AND post_status='pending' AND post_author='$userId'";
        $count = $wpdb->get_var($query . $where);
		echo $count;
}




// Create membership area

function membershiparea() { ?>
	<?php if ( !get_option('users_can_register') ) { ?>
    <?php } else { ?>
    	<?php if ( is_user_logged_in() ) { // IF USER IS LOGGED IN ?>
    		<div id="membership">
    			<div class="membership_first">
    				<div class="membership_pad">
    					<b><?php _e( 'Welcome back,', 'mediafap' ); ?>&nbsp;<a href="<?php echo home_url(); ?>/wp-admin/profile.php" title="<?php _e( 'My Profile', 'mediafap' ); ?>">
    					<?php global $current_user; get_currentuserinfo(); echo $current_user->display_name; ?></a></b>&nbsp;(<?php echo get_user_role(); ?>)<br />
    					<?php _e( 'Posts Published:', 'mediafap' ); ?>&nbsp;<a href="<?php echo home_url(); ?>/wp-admin/edit.php?post_type=post&post_status=published&author=<?php global $current_user; get_currentuserinfo(); echo $current_user->ID; ?>" title="<?php _e( 'My Published Posts:', 'mediafap' ); ?>">&nbsp;<?php postCount(); ?></a> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <?php _e( 'My Posts Pending', 'mediafap' ); ?>&nbsp;<a href="<?php echo home_url(); ?>/wp-admin/edit.php?post_type=post&post_status=pending&author=<?php global $current_user; get_currentuserinfo(); echo $current_user->ID; ?>" title="<?php _e( 'My Pending Posts', 'mediafap' ); ?>"><?php pendingCount(); ?></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?php wp_register('', ''); ?>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?php wp_loginout(); ?>
    				</div>
    			</div>
    			<div class="membership_second">
    				<div class="membership_pad">
    					<a href="http://gravatar.com" target="_blank" title="<?php _e( 'My Gravatar', 'mediafap' ); ?>"><?php global $current_user; get_currentuserinfo(); echo get_avatar( $current_user->ID, 30 ); ?></a>
    				</div>
    			</div>
    		</div>
		<?php } else { // IF USER IS NOT LOGGED IN ?>
			<div id="membership">
    			<div class="membership_first">
    				<div class="membership_pad">
    					<b><?php _e( 'Welcome visitor,', 'mediafap' ); ?>&nbsp;</b><?php _e( 'you are currently not logged in.', 'mediafap' ); ?><br />
    					<?php wp_register('', ''); ?>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?php wp_loginout(); ?>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(<a href="<?php echo home_url(); ?>/wp-login.php?action=lostpassword"><?php _e( 'Lost Password?', 'mediafap' ); ?></a>)
    				</div>
    			</div>
    			<div class="membership_second">
    				<div class="membership_pad">
    					<a href="http://gravatar.com" target="_blank" title="<?php _e( 'My Gravatar', 'mediafap' ); ?>"><?php global $current_user; get_currentuserinfo(); echo get_avatar( $current_user->ID, 30 ); ?></a>
    				</div>
    			</div>
    		</div>
    	<?php } ?>
    <?php } ?>
<?php }
	



// Include all related asset files for theme options

	function mytheme_add_init() {
		global $shortname;
		$file_dir=get_bloginfo('template_directory');
		wp_enqueue_style("theme_functions", $file_dir."/options.css", false, "1.0", "all");
	 	wp_enqueue_script("rm_script", $file_dir."/js/rm_script.js", false, "1.0");
}




// Create the save & delete buttons for theme options

	function mytheme_admin() {
	global $themename, $shortname, $options;
		$i=0;
	if ( isset($_REQUEST['saved']) &&  $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>Options Saved.</strong></p></div>';
	if ( isset($_REQUEST['reset']) &&  $_REQUEST['reset'] ) echo '<div id="message" class="updated fade"><p><strong>Options Reset.</strong></p></div>';
	
	

	
// Build the theme options input fields

?>
<div class="wrap rm_wrap">
<div id="icon-themes" class="icon32"><br /></div><h2><?php _e( 'Theme Options', 'mediafap' ); ?></h2>
<div style="padding: 0px 0px 10px 0px;"></div>
	<div class="rm_opts">
		<form method="post">
			<?php foreach ($options as $value) {
				switch ( $value['type'] ) {
				case "open":
			?>
		<?php break;
			case "close":
		?>
	</div>
</div>
<div style="margin-bottom: 1px;"></div>
<?php break;
	case "title":
?>
<?php break;
	case 'text':
?>
<div class="rm_input rm_text">
	<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
 	<input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_option( $value['id'] ) != "") { echo stripslashes(get_option( $value['id'])  ); } else { echo $value['std']; } ?>" />
	<small><?php echo $value['desc']; ?></small><div class="clearfix"></div>
</div>
<?php
	break;
	case 'textarea':
?>
<div class="rm_input rm_textarea">
	<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
 	<textarea name="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" cols="" rows=""><?php if ( get_option( $value['id'] ) != "") { echo stripslashes(get_option( $value['id']) ); } else { echo $value['std']; } ?></textarea>
	<small><?php echo $value['desc']; ?></small><div class="clearfix"></div>
</div>
<?php
	break;
	case 'select':
?>
<div class="rm_input rm_select">
	<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
	<select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
		<?php foreach ($value['options'] as $option) { ?>
		<option <?php if (get_option( $value['id'] ) == $option) { echo 'selected="selected"'; } ?>><?php echo $option; ?></option><?php } ?>
	</select>
	<small><?php echo $value['desc']; ?></small><div class="clearfix"></div>
</div>
<?php
	break;
	case "checkbox":
?>
<div class="rm_input rm_checkbox">
	<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
	<?php if(get_option($value['id'])){ $checked = "checked=\"checked\""; }else{ $checked = "";} ?>
	<input type="checkbox" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" value="true" <?php echo $checked; ?> />
	<small><?php echo $value['desc']; ?></small><div class="clearfix"></div>
</div>
<?php break; 
	case "section":
	$i++;
?>
<div class="rm_section">
	<div class="rm_title">
		<h3><?php echo $value['name']; ?></h3>
		<span class="submit"><input name="save<?php echo $i; ?>" class="button button-primary" type="submit" value="Save Options" /></span>
		<div class="clearfix"></div>
	</div>
	<div class="rm_options">
		<?php break;
				}
			}
		?>
		<input type="hidden" name="action" value="save" />
</form>
</div>
<?php
}
?>
<?php
add_action('admin_init', 'mytheme_add_init');
add_action('admin_menu', 'mytheme_add_admin');
?>
<?php




// Load all necessary javascript files for the theme
	
function my_scripts_method() {
	
		$crawler= get_template_directory_uri() . "/js/crawler.js";
		wp_deregister_script( 'crawler' );
		wp_register_script( 'crawler', $crawler);
		wp_enqueue_script( 'crawler');
		
		$jquerytools= get_template_directory_uri() . "/js/jquery.tools.min.js";
		wp_deregister_script( 'jquerytools' );
		wp_register_script( 'jquerytools', $jquerytools);
		wp_enqueue_script( 'jquerytools');
		
		$jqueryui= get_template_directory_uri() . "/js/jquery-ui-1.10.2.js";
		wp_deregister_script( 'jqueryui' );
		wp_register_script( 'jqueryui', $jqueryui);
		wp_enqueue_script( 'jqueryui');
		
		$opacity= get_template_directory_uri() . "/js/opacity.js";
		wp_deregister_script( 'opacity' );
		wp_register_script( 'opacity', $opacity);
		wp_enqueue_script( 'opacity');
		
		$tooltip= get_template_directory_uri() . "/js/tooltip.js";
		wp_deregister_script( 'tooltip' );
		wp_register_script( 'tooltip', $tooltip);
		wp_enqueue_script( 'tooltip');
		
		$backtotop= get_template_directory_uri() . "/js/backtotop.js";
		wp_deregister_script( 'backtotop' );
		wp_register_script( 'backtotop', $backtotop);
		wp_enqueue_script( 'backtotop');

}
add_action('wp_enqueue_scripts', 'my_scripts_method');




// Load all javascript files for use by the logo uploader only
	
	function customlogo_options_enqueue_scripts() {
	
		wp_register_script( 'customlogo-upload', get_template_directory_uri() .'/js/logo.js', array('jquery','media-upload','thickbox') );	

		if ( 'appearance_page_customlogo-settings' == get_current_screen() -> id ) {
			wp_enqueue_script('jquery');
			wp_enqueue_script('thickbox');
			wp_enqueue_style('thickbox');
			wp_enqueue_script('media-upload');
			wp_enqueue_script('customlogo-upload');
		}
	}
	add_action('admin_enqueue_scripts', 'customlogo_options_enqueue_scripts');
	
	
	

// Build the logo uploader

function customlogo_get_default_options() {
	$options = array(
		'logo' => ''
	);
	return $options;
}

function customlogo_options_init() {
     $customlogo_options = get_option( 'theme_customlogo_options' );
	 
     if ( false === $customlogo_options ) {
          $customlogo_options = customlogo_get_default_options();
		  add_option( 'theme_customlogo_options', $customlogo_options );
     }
}

add_action( 'after_setup_theme', 'customlogo_options_init' );

function customlogo_options_setup() {
	global $pagenow;
	if ('media-upload.php' == $pagenow || 'async-upload.php' == $pagenow) {
		add_filter( 'gettext', 'replace_thickbox_text' , 1, 2 );
	}
}
add_action( 'admin_init', 'customlogo_options_setup' );

function replace_thickbox_text($translated_text, $text ) {	
	if ( 'Insert into Post' == $text ) {
		$referer = strpos( wp_get_referer(), 'customlogo-settings' );
		if ( $referer != '' ) {
			return __('Use as Logo', 'customlogo' );
		}
	}

	return $translated_text;
}

function customlogo_menu_options() {
     add_theme_page('Logo', 'Logo', 'edit_theme_options', 'customlogo-settings', 'customlogo_admin_options_page');
}

add_action('admin_menu', 'customlogo_menu_options');

function customlogo_admin_options_page() {
?>
<div class="wrap">
	<div id="icon-themes" class="icon32"><br /></div>
	<h2><?php _e( 'Custom Logo', 'mediafap' ); ?></h2>
	<?php settings_errors( 'customlogo-settings-errors' ); ?>
	<form id="form-customlogo-options" action="options.php" method="post" enctype="multipart/form-data">
		<?php
			settings_fields('theme_customlogo_options');
			do_settings_sections('customlogo');
		?>
		<p class="submit">
			<input name="theme_customlogo_options[submit]" id="submit_options_form" type="submit" class="button-primary" value="<?php esc_attr_e('Save Settings', 'mediafap'); ?>" />
			<input name="theme_customlogo_options[reset]" type="submit" class="button-secondary" value="<?php esc_attr_e('Reset Defaults', 'mediafap'); ?>" />		
		</p>
	</form>
</div>
<?php
}

function customlogo_options_validate( $input ) {
	$default_options = customlogo_get_default_options();
	$valid_input = $default_options;
	
	$customlogo_options = get_option('theme_customlogo_options');
	
	$submit = ! empty($input['submit']) ? true : false;
	$reset = ! empty($input['reset']) ? true : false;
	$delete_logo = ! empty($input['delete_logo']) ? true : false;
	
	if ( $submit ) {
		if ( $customlogo_options['logo'] != $input['logo']  && $customlogo_options['logo'] != '' )
			delete_image( $customlogo_options['logo'] );
		
		$valid_input['logo'] = $input['logo'];
	}
	elseif ( $reset ) {
		delete_image( $customlogo_options['logo'] );
		$valid_input['logo'] = $default_options['logo'];
	}
	elseif ( $delete_logo ) {
		delete_image( $customlogo_options['logo'] );
		$valid_input['logo'] = '';
	}
	
	return $valid_input;
}

function delete_image( $image_url ) {
	global $wpdb;
	
	$query = "SELECT ID FROM wp_posts where guid = '" . esc_url($image_url) . "' AND post_type = 'attachment'";  
	$results = $wpdb -> get_results($query);

	foreach ( $results as $row ) {
		wp_delete_attachment( $row -> ID );
	}	
}

function customlogo_options_settings_init() {
	register_setting( 'theme_customlogo_options', 'theme_customlogo_options', 'customlogo_options_validate' );
	add_settings_section('customlogo_settings_header', __( 'Logo Options', 'customlogo' ), 'customlogo_settings_header_text', 'customlogo');
	add_settings_field('customlogo_setting_logo',  __( 'Logo', 'customlogo' ), 'customlogo_setting_logo', 'customlogo', 'customlogo_settings_header');
	add_settings_field('customlogo_setting_logo_preview',  __( 'Logo Preview', 'customlogo' ), 'customlogo_setting_logo_preview', 'customlogo', 'customlogo_settings_header');
}
add_action( 'admin_init', 'customlogo_options_settings_init' );

function customlogo_setting_logo_preview() {
	$customlogo_options = get_option( 'theme_customlogo_options' );  ?>
	<div id="upload_logo_preview" style="min-height: 100px;">
		<img style="max-width:100%;" src="<?php echo esc_url( $customlogo_options['logo'] ); ?>" />
	</div>
	<?php
}

function customlogo_settings_header_text() {
	?>
		<p><?php _e( 'You can upload any custom image to use as your logo.', 'mediafap' ); ?></p>
        <p><b><?php _e( '400px maximum width, 55px recommended height', 'mediafap' ); ?></b></p>
	<?php
}

function customlogo_setting_logo() {
	$customlogo_options = get_option( 'theme_customlogo_options' );
	?>
		<input type="hidden" id="logo_url" name="theme_customlogo_options[logo]" value="<?php echo esc_url( $customlogo_options['logo'] ); ?>" />
		<input id="upload_logo_button" type="button" class="button" value="<?php _e( 'Upload Logo', 'mediafap' ); ?>" />
		<?php if ( '' != $customlogo_options['logo'] ): ?>
			<input id="delete_logo_button" name="theme_customlogo_options[delete_logo]" type="submit" class="button" value="<?php _e( 'Delete Logo', 'mediafap' ); ?>" />
		<?php endif; ?>
	<?php
}




// Create XHTML	Language Attributes

function create_valid_xhtml_1_1($language_attributes) 
{
	return preg_replace('/ lang=\"[a-z]+\-[A-Z]+\"/', '', $language_attributes);
}
add_filter('language_attributes', 'create_valid_xhtml_1_1');




// Create language textdomain

add_action('after_setup_theme', 'int_setup');
function int_setup(){
    load_theme_textdomain('mediafap', get_template_directory() . '/lang');
}




// Include default Wordpress features

add_editor_style('editor.css');
add_theme_support( 'automatic-feed-links' );
if ( ! isset( $content_width ) ) $content_width = 1210;




// Add custom background function

add_theme_support( 'custom-background' );




// Register Wordpress menu function

add_theme_support( 'menus' );
register_nav_menus( array(
	'main_menu' => 'Main Menu'
) );




// Load all necessary stylesheets

function themecolors()
{
	wp_register_style( 'default', get_template_directory_uri() . '/style.css', array(), '20120917', 'all' );
	if ( get_option( 'mediafap_selectscheme' ) == "Candyfloss") {
		wp_register_style( 'candyfloss', get_template_directory_uri() . '/styles/candyfloss.css', array(), '20120917', 'all' );
	} else {
		if ( get_option( 'mediafap_selectscheme' ) == "Sky") {
			wp_register_style( 'sky', get_template_directory_uri() . '/styles/sky.css', array(), '20120917', 'all' );
		} else {
			if ( get_option( 'mediafap_selectscheme' ) == "Mint") {
				wp_register_style( 'mint', get_template_directory_uri() . '/styles/mint.css', array(), '20120917', 'all' );
			} else {
				if ( get_option( 'mediafap_selectscheme' ) == "Cherry") {
					wp_register_style( 'cherry', get_template_directory_uri() . '/styles/cherry.css', array(), '20120917', 'all' );
				} else {
					if ( get_option( 'mediafap_selectscheme' ) == "Forest") {
						wp_register_style( 'forest', get_template_directory_uri() . '/styles/forest.css', array(), '20120917', 'all' );
					} else {
						if ( get_option( 'mediafap_selectscheme' ) == "Lemonade") {
							wp_register_style( 'lemonade', get_template_directory_uri() . '/styles/lemonade.css', array(), '20120917', 'all' );
						} else {
							if ( get_option( 'mediafap_selectscheme' ) == "Midnight") {
								wp_register_style( 'midnight', get_template_directory_uri() . '/styles/midnight.css', array(), '20120917', 'all' );
							} else {
							}
						}
					}
				}
			}
		}
	}
	wp_enqueue_style( 'default' );
	wp_enqueue_style( 'candyfloss' );
	wp_enqueue_style( 'sky' );
	wp_enqueue_style( 'mint' );
	wp_enqueue_style( 'cherry' );
	wp_enqueue_style( 'forest' );
	wp_enqueue_style( 'lemonade' );
	wp_enqueue_style( 'midnight' );
}
add_action( 'wp_enqueue_scripts', 'themecolors' );



// Register all the fonts

function themefonts()
{
	wp_register_style( 'googlefonts', 'http://fonts.googleapis.com/css?family=Playball|Yesteryear|Kaushan+Script|Dynalight|Lobster+Two|Playfair+Display|Open+Sans|Oswald|Source+Sans+Pro|Special+Elite|Mouse+Memoirs', array(), '20120917', 'all' );
	if ( get_option( 'mediafap_selectfontheadings' ) == "Arial") {
		wp_register_style( 'arial', get_template_directory_uri() . '/fonts/arial.css', array(), '20120917', 'all' );
	} else {
		if ( get_option( 'mediafap_selectfontheadings' ) == "Trebuchet") {
			wp_register_style( 'trebuchet', get_template_directory_uri() . '/fonts/trebuchet.css', array(), '20120917', 'all' );
		} else {
			if ( get_option( 'mediafap_selectfontheadings' ) == "Playball") {
				wp_register_style( 'playball', get_template_directory_uri() . '/fonts/playball.css', array(), '20120917', 'all' );
			} else {
				if ( get_option( 'mediafap_selectfontheadings' ) == "Yesteryear") {
					wp_register_style( 'yesteryear', get_template_directory_uri() . '/fonts/yesteryear.css', array(), '20120917', 'all' );
				} else {
					if ( get_option( 'mediafap_selectfontheadings' ) == "Kaushan Script") {
						wp_register_style( 'kaushanscript', get_template_directory_uri() . '/fonts/kaushanscript.css', array(), '20120917', 'all' );
					} else {
						if ( get_option( 'mediafap_selectfontheadings' ) == "Dynalight") {
							wp_register_style( 'dynalight', get_template_directory_uri() . '/fonts/dynalight.css', array(), '20120917', 'all' );
						} else {
							if ( get_option( 'mediafap_selectfontheadings' ) == "Lobster Two") {
								wp_register_style( 'lobstertwo', get_template_directory_uri() . '/fonts/lobstertwo.css', array(), '20120917', 'all' );
							} else {
								if ( get_option( 'mediafap_selectfontheadings' ) == "Playfair Display") {
									wp_register_style( 'playfair', get_template_directory_uri() . '/fonts/playfair.css', array(), '20120917', 'all' );
								} else {
									if ( get_option( 'mediafap_selectfontheadings' ) == "Open Sans") {
										wp_register_style( 'opensans', get_template_directory_uri() . '/fonts/opensans.css', array(), '20120917', 'all' );
									} else {
										if ( get_option( 'mediafap_selectfontheadings' ) == "Oswald") {
											wp_register_style( 'oswald', get_template_directory_uri() . '/fonts/oswald.css', array(), '20120917', 'all' );
										} else {
											if ( get_option( 'mediafap_selectfontheadings' ) == "Source Sans Pro") {
												wp_register_style( 'sourcesanspro', get_template_directory_uri() . '/fonts/sourcesanspro.css', array(), '20120917', 'all' );
											} else {
												if ( get_option( 'mediafap_selectfontheadings' ) == "Special Elite") {
													wp_register_style( 'specialelite', get_template_directory_uri() . '/fonts/specialelite.css', array(), '20120917', 'all' );
												} else {
													if ( get_option( 'mediafap_selectfontheadings' ) == "Mouse Memoirs") {
														wp_register_style( 'mousememoirs', get_template_directory_uri() . '/fonts/mousememoirs.css', array(), '20120917', 'all' );
													} else {
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	wp_enqueue_style( 'googlefonts' );
	wp_enqueue_style( 'arial' );
	wp_enqueue_style( 'trebuchet' );
	wp_enqueue_style( 'playball' );
	wp_enqueue_style( 'yesteryear' );
	wp_enqueue_style( 'kaushanscript' );
	wp_enqueue_style( 'dynalight' );
	wp_enqueue_style( 'lobstertwo' );
	wp_enqueue_style( 'playfair' );
	wp_enqueue_style( 'opensans' );
	wp_enqueue_style( 'oswald' );
	wp_enqueue_style( 'sourcesanspro' );
	wp_enqueue_style( 'specialelite' );
	wp_enqueue_style( 'mousememoirs' );
}
add_action( 'wp_enqueue_scripts', 'themefonts' );






// Load all responsive stylesheets

function responsive()
	{
		wp_register_style( 'desktop', get_template_directory_uri() . '/desktop.css', array(), '20120917', 'all' );
		wp_register_style( 'tablet', get_template_directory_uri() . '/tablet.css', array(), '20120917', 'all' );
		wp_register_style( 'horizontal', get_template_directory_uri() . '/horizontal.css', array(), '20120917', 'all' );
		wp_register_style( 'vertical', get_template_directory_uri() . '/vertical.css', array(), '20120917', 'all' );
		wp_register_style( 'slim', get_template_directory_uri() . '/slim.css', array(), '20120917', 'all' );
		wp_enqueue_style( 'desktop' );
		wp_enqueue_style( 'tablet' );
		wp_enqueue_style( 'horizontal' );
		wp_enqueue_style( 'vertical' );
		wp_enqueue_style( 'slim' );
	}
add_action( 'wp_enqueue_scripts', 'responsive' );




// Create the options for the theme options page

	$options = array (
	array( "name" => $themename." Theme Options",
		"type" => "title"),
		array( "name" => "Global",
			"type" => "section"),
		array( "type" => "open"),
	  		array(	"name" => "Custom Sitename",
				"desc" => "Enter your custom sitename text, this text will not be displayed if you have an <a href=\"../wp-admin/themes.php?page=customlogo-settings\">image uploaded</a> as your logo.",
	    		"id" => $shortname."_sitename",
	    		"std" => "",
	    		"type" => "text"
			),
			array(	"name" => "Fonts",						
				"desc" => "Select which font you would like to use for the text sitename.",
				"id" => $shortname."_selectfontheadings",
				"type" => "select",
				"std" => "Trebuchet",
				"options" => array("Arial","Dynalight","Kaushan Script","Lobster Two","Mouse Memoirs","Open Sans","Oswald","Playball","Playfair Display","Source Sans Pro","Special Elite","Trebuchet","Yesteryear")
			),
			array(	"name" => "Color Scheme",						
				"desc" => "Select a color scheme, you can also add your own <a href=\"../wp-admin/themes.php?page=custom-background\">background color &amp; image</a> too.",
				"id" => $shortname."_selectscheme",
				"type" => "select",
				"std" => "Candyfloss",
				"options" => array("Candyfloss","Sky","Mint","Cherry","Forest","Lemonade","Midnight")
			),
			array(	"name" => "Layout",						
				"desc" => "Select which layout to use for your homepage.",
				"id" => $shortname."_homecount",
				"type" => "select",
				"std" => "Magazine (S)",
				"options" => array("Magazine (S)","Magazine (M)","Magazine (L)","Magazine (XL)","Magazine (XXL)", "Blog (Excerpts)", "Blog (Full)")
			),
			array(	"name" => "Date Format",						
				"desc" => "Select the format for your post dates.",
				"id" => $shortname."_dateformat",
				"type" => "select",
				"std" => "US",
				"options" => array("US","EU")
			),
		array( "type" => "close"),
		array( "name" => "Comments",
			"type" => "section"),
		array( "type" => "open"),
			array(	"name" => "Comments Selector",						
				"desc" => "Select your preferred commenting system for your posts, further information may be required below depending on your selection.<br /><br />Remember, you can also disable any commenting system on a per-post basis when writing a new post.",
				"id" => $shortname."_selectcomments",
				"type" => "select",
				"std" => "None",
				"options" => array("None","Wordpress","Disqus")
			),
			array(	"name" => "Disqus Universal Code",
				"desc" => "If you chose the Disqus commenting system above, paste your <a href=\"http://disqus.com/admin/signup/\" target=\"_blank\" title=\"Get your Univeral Disqus code\">Universal Code</a> here.<br /><br />Make sure you use the Universal Code option.",
	    		"id" => $shortname."_selectcommentsdisqus",
	    		"std" => "",
	    		"type" => "textarea"
			),
		array( "type" => "close"),
		array( "name" => "Advertising",
			"type" => "section"),
		array( "type" => "open"),
			array(	"name" => "Top",
				"desc" => "Add your advertisement banner code here (468*60px only).",
	    		"id" => $shortname."_bannertop",
	    		"std" => "",
	    		"type" => "textarea"
			),
		array( "type" => "close"),
		array( "name" => "Social Networking",
			"type" => "section"),
		array( "type" => "open"),
			array(	"name" => "Social Counters",						
				"desc" => "Select wether to enable the social counters on each of your posts.",
				"id" => $shortname."_postsocialselector",
				"type" => "select",
				"std" => "Enable",
				"options" => array("Enable","Disable")
			),
			array(	"name" => "Social Sidebar",						
				"desc" => "Select wether to enable the floating social sidebar.",
				"id" => $shortname."_floatingsocial",
				"type" => "select",
				"std" => "Enable",
				"options" => array("Enable","Disable")
			),
		array( "type" => "close"),
		array( "name" => "Miscellaneous",
			"type" => "section"),
		array( "type" => "open"),
	  		array("name" => "Site Description",
				"desc" => "Enter your chosen META description for this website, search engines use it to display your site in their results.",
	    		"id" => $shortname."_description",
	    		"std" => "",
	    		"type" => "textarea"
			),
	  		array(	"name" => "Site Keywords",
				"desc" => "Enter your chosen META keywords that are relevant to your site contents, seperate keywords with commas (keyword1, keyword2, keyword3 etc..).",
	    		"id" => $shortname."_keywords",
	    		"std" => "",
	    		"type" => "textarea"
			),
	  		array(	"name" => "Analytics",
				"desc" => "Add your analytics tracking code here from Google Analytics, or similar.",
	    		"id" => $shortname."_analytics",
	    		"std" => "",
	    		"type" => "textarea"
			),
		array( "type" => "close"),
		array( "name" => "Footer",
			"type" => "section"),
		array( "type" => "open"),
	  		array(	"name" => "Copyright",
				"desc" => "Add your custom copyright text here (Custom HTML is allowed for linking).",
	    		"id" => $shortname."_copyright",
	    		"std" => "",
	    		"type" => "textarea"
			),
			array(	"name" => "Back to Top",						
				"desc" => "Select wether to enable the floating back to top button.",
				"id" => $shortname."_backtop",
				"type" => "select",
				"std" => "Enable",
				"options" => array("Enable","Disable")
			),
		array( "type" => "close")
	);




// Register all widgetised sidebars

if (function_exists('register_sidebar'))
	{
		register_sidebar(array(
			'description' => 'Drop widgets here and they will be displayed on all posts and pages.',
			'before_widget' => '<div class="widget">',
			'after_widget' => '</div>',
			'before_title' => '<h4>',
			'after_title' => '</h4>',
			'name' => 'Post Sidebar'
		));
	}
	
if (function_exists('register_sidebar'))
	{
		register_sidebar(array(
			'description' => 'Drop widgets here and they will be displayed on all archive pages.',
			'before_widget' => '<div class="widget">',
			'after_widget' => '</div>',
			'before_title' => '<h4>',
			'after_title' => '</h4>',
			'name' => 'Archive Sidebar'
		));
	}
	



// Display all widgetised areas
		
function widget_post_side() { ?>
	<?php if ( function_exists('dynamic_sidebar') && dynamic_sidebar('Post Sidebar') ) : else : ?>
	<?php endif; ?>
<?php }

function widget_archive_side() { ?>
	<?php if ( function_exists('dynamic_sidebar') && dynamic_sidebar('Archive Sidebar') ) : else : ?>
    	<?php if ( function_exists('dynamic_sidebar') && dynamic_sidebar('Post Sidebar') ) : else : ?>
		<?php endif; ?>
	<?php endif; ?>
<?php }




// Unregister some default Wordpress widgets

	function unregister_default_wp_widgets() { 
		unregister_widget('WP_Nav_Menu_Widget');
	}
	add_action('widgets_init', 'unregister_default_wp_widgets', 1);
	
	


// Get author data

	if(get_query_var('author_name')) :
		$curauth = get_userdatabylogin(get_query_var('author_name'));
	else :
		$curauth = get_userdata(get_query_var('author'));
	endif;
	
	
	

// Remove filters from commenting widget

	function remove_wp_widget_recent_comments_style() {
	   if ( has_filter('wp_head', 'wp_widget_recent_comments_style') ) {
	      remove_filter('wp_head', 'wp_widget_recent_comments_style' );
	   }
	}
	add_filter( 'wp_head', 'remove_wp_widget_recent_comments_style', 1 );




// Default Wordpress comments
		
if ( ! function_exists( 'mediafap_comment' ) ) :

function mediafap_comment( $comment, $args, $depth ) {
	$GLOBALS['comment'] = $comment;
	switch ( $comment->comment_type ) :
		case 'pingback' :
		case 'trackback' :
	?>
	<li class="post pingback">
		<p><?php _e( 'Pingback:', 'mediafap' ); ?> <?php comment_author_link(); ?><?php edit_comment_link( __( 'Edit', 'mediafap' ), '<span class="edit-link">', '</span>' ); ?></p>
	<?php
			break;
		default :
	?>
	<li <?php comment_class(); ?> id="li-comment-<?php comment_ID(); ?>">
		<div id="comment-<?php comment_ID(); ?>" class="comment">
			<div class="comment-meta">
				<div class="comment-author vcard">
					<?php
						$avatar_size = 68;
						if ( '0' != $comment->comment_parent )
							$avatar_size = 39;

						echo get_avatar( $comment, $avatar_size );

						printf( __( '%1$s on %2$s <span class="says">said:</span>', 'mediafap' ),
							sprintf( '<span class="fn">%s</span>', get_comment_author_link() ),
							sprintf( '<a href="%1$s">%3$s</a>',
								esc_url( get_comment_link( $comment->comment_ID ) ),
								get_comment_time( 'c' ),
								sprintf( __( '%1$s at %2$s', 'mediafap' ), get_comment_date(), get_comment_time() )
							)
						);
					?>

					<?php edit_comment_link( __( 'Edit', 'mediafap' ), '<span class="edit-link">', '</span>' ); ?>
				</div>
				<?php if ( $comment->comment_approved == '0' ) : ?>
					<em class="comment-awaiting-moderation"><?php _e( 'Your comment is awaiting moderation.', 'mediafap' ); ?></em>
					<br />
				<?php endif; ?>

			</div>

			<div class="comment-content"><?php comment_text(); ?></div>

			<div class="reply">
				<?php comment_reply_link( array_merge( $args, array( 'reply_text' => __( 'Reply <span>&darr;</span>', 'mediafap' ), 'depth' => $depth, 'max_depth' => $args['max_depth'] ) ) ); ?>
			</div><!-- .reply -->
		</div><!-- #comment-## -->

	<?php
			break;
	endswitch;
}
endif;




// Create title length control functions

function trim_title_shortest() {
	$title = get_the_title();
	$limit = "12";
	$pad=" &raquo;";
	if(strlen($title) <= $limit) {
		echo $title;
	} else {
		$title = substr($title, 0, $limit) . $pad;
	echo $title;
	}
} 
function trim_title_shorter() {
	$title = get_the_title();
	$limit = "24";
	$pad=" &raquo;";
	if(strlen($title) <= $limit) {
		echo $title;
	} else {
		$title = substr($title, 0, $limit) . $pad;
	echo $title;
	}
} 
function trim_title_short() {
	$title = get_the_title();
	$limit = "26";
	$pad=" &raquo;";
	if(strlen($title) <= $limit) {
		echo $title;
	} else {
		$title = substr($title, 0, $limit) . $pad;
	echo $title;
	}
}
function trim_title_moderate() {
	$title = get_the_title();
	$limit = "44";
	$pad=" &raquo;";
	if(strlen($title) <= $limit) {
		echo $title;
	} else {
		$title = substr($title, 0, $limit) . $pad;
	echo $title;
	}
}
function trim_title_long() {
	$title = get_the_title();
	$limit = "64";
	$pad=" &raquo;";
	if(strlen($title) <= $limit) {
		echo $title;
	} else {
		$title = substr($title, 0, $limit) . $pad;
	echo $title;
	}
}
function trim_title_longer() {
	$title = get_the_title();
	$limit = "74";
	$pad=" &raquo;";
	if(strlen($title) <= $limit) {
		echo $title;
	} else {
		$title = substr($title, 0, $limit) . $pad;
	echo $title;
	}
}




// Create theme shortcodes

	function warning_shortcode( $atts, $content = null ) {
		return '<div class="warning">' . $content . '</div>';
	}
	add_shortcode('warning', 'warning_shortcode');
	
	
	function approved_shortcode( $atts, $content = null ) {
		return '<div class="approved">' . $content . '</div>';
	}
	add_shortcode('approved', 'approved_shortcode');
	
	
	function notice_shortcode( $atts, $content = null ) {
		return '<div class="notice">' . $content . '</div>';
	}
	add_shortcode('notice', 'notice_shortcode');
	
	
	function codeslide_shortcode( $atts, $content = null ) {
		return '<div class="codeslide">' . $content . '</div>';
	}
	add_shortcode('codeslide', 'codeslide_shortcode');
	
	
	function code_shortcode( $atts, $content = null ) {
		return '<div class="code">' . $content . '</div>';
	}
	add_shortcode('code', 'code_shortcode');
	
	
	function floatleft_shortcode( $atts, $content = null ) {
		return '<div class="floatleft">' . $content . '</div>';
	}
	add_shortcode('floatleft', 'floatleft_shortcode');
	
	
	function floatright_shortcode( $atts, $content = null ) {
		return '<div class="floatright">' . $content . '</div>';
	}
	add_shortcode('floatright', 'floatright_shortcode');




// Create custom pagination function

function pagination($pages = '', $range = 4)
	{
		$showitems = ($range * 2)+1;  
		global $paged;
		if(empty($paged)) $paged = 1;
		if($pages == '')
	{
	global $wp_query;
	$pages = $wp_query->max_num_pages;
	if(!$pages)
		{
			$pages = 1;
		}
	}   
	if(1 != $pages)
	{
		echo "<div class=\"pagination\"><span>Page ".$paged." of ".$pages."</span>";
		if($paged > 2 && $paged > $range+1 && $showitems < $pages) echo "<a href='".get_pagenum_link(1)."'>&laquo; First</a>";
		if($paged > 1 && $showitems < $pages) echo "<a href='".get_pagenum_link($paged - 1)."'>&lsaquo; Previous</a>";
			for ($i=1; $i <= $pages; $i++)
		{
		if (1 != $pages &&( !($i >= $paged+$range+1 || $i <= $paged-$range-1) || $pages <= $showitems ))
			{
				echo ($paged == $i)? "<span class=\"current\">".$i."</span>":"<a href='".get_pagenum_link($i)."' class=\"inactive\">".$i."</a>";
			}
		}
		if ($paged < $pages && $showitems < $pages) echo "<a href=\"".get_pagenum_link($paged + 1)."\">Next &rsaquo;</a>";
		if ($paged < $pages-1 &&  $paged+$range-1 < $pages && $showitems < $pages) echo "<a href='".get_pagenum_link($pages)."'>Last &raquo;</a>";
			echo "</div>\n";
		}
	}




// Register all image thumbnail size functions

if ( function_exists( 'add_theme_support' ) )
add_theme_support( 'post-thumbnails' );
set_post_thumbnail_size( 280, 215, true );
add_image_size( 'img_post', 550, 400, true );
add_image_size( 'img_desktop', 360, 262, true );
add_image_size( 'img_archive', 350, 200, true );
add_image_size( 'img_horizontal', 250, 182, true );
add_image_size( 'img_vertical', 247, 180, true );
add_image_size( 'img_550', 550, 300, true );
add_image_size( 'img_475', 475, 265, true );
add_image_size( 'img_415', 415, 265, true );
add_image_size( 'img_400', 400, 300, true );
add_image_size( 'img_350', 350, 300, true );
add_image_size( 'img_346', 346, 300, true );
add_image_size( 'img_346b', 346, 300, true );
add_image_size( 'img_346c', 346, 300, true );
add_image_size( 'img_346d', 346, 300, true );
add_image_size( 'img_346e', 346, 300, true );
add_image_size( 'img_346f', 346, 300, true );
add_image_size( 'img_346g', 346, 300, true );
add_image_size( 'img_345', 345, 200, true );
add_image_size( 'img_340', 340, 505, true );
add_image_size( 'img_300', 300, 200, true );
add_image_size( 'img_300b', 300, 145, true );
add_image_size( 'img_300c', 300, 145, true );
add_image_size( 'img_290', 290, 250, true );
add_image_size( 'img_278', 278, 250, true );
add_image_size( 'img_277', 277, 250, true );
add_image_size( 'img_275', 275, 265, true );
add_image_size( 'img_297', 297, 300, true );
add_image_size( 'img_297b', 297, 300, true );
add_image_size( 'img_297c', 297, 300, true );
add_image_size( 'img_246', 246, 300, true );
add_image_size( 'img_246b', 246, 300, true );
add_image_size( 'img_246c', 246, 300, true );
add_image_size( 'img_246d', 246, 300, true );
add_image_size( 'img_246e', 246, 300, true );
add_image_size( 'img_235', 235, 235, true );
add_image_size( 'img_235b', 235, 235, true );
add_image_size( 'img_235c', 235, 235, true );
add_image_size( 'img_235d', 235, 235, true );
add_image_size( 'img_230', 230, 165, true );
add_image_size( 'img_205', 205, 235, true );
add_image_size( 'img_205b', 205, 235, true );
add_image_size( 'img_205c', 205, 235, true );
add_image_size( 'img_200', 200, 200, true );
add_image_size( 'img_198', 198, 200, true );
add_image_size( 'img_197', 197, 200, true );
add_image_size( 'img_197b', 197, 200, true );
add_image_size( 'img_197c', 197, 200, true );
add_image_size( 'img_197d', 197, 200, true );
add_image_size( 'img_197e', 197, 200, true );
add_image_size( 'img_197f', 197, 200, true );
add_image_size( 'img_178', 178, 250, true );
add_image_size( 'img_177', 177, 250, true );
add_image_size( 'img_173', 173, 200, true );
add_image_size( 'img_172', 172, 200, true );
add_image_size( 'img_172b', 172, 200, true );
add_image_size( 'img_147', 147, 150, true );
add_image_size( 'img_148', 148, 150, true );
add_image_size( 'img_135', 135, 235, true );
add_image_size( 'img_135b', 135, 235, true );
add_image_size( 'img_135c', 135, 235, true );
add_image_size( 'img_135d', 135, 235, true );
add_image_size( 'img_80', 80, 80, true );





// Create custom post meta boxes

$prefix = 'mediafap_';

$meta_box = array(
	'id' => 'post-meta-boxes',
	'title' => 'Post Options',
	'page' => 'post',
	'context' => 'normal',
	'priority' => 'high',
	'fields' => array(
array(
            'name' => 'Comments',
            'desc' => 'Check the box to disable all comments on this post',
            'id' => $prefix . 'nocommentpost',
            'type' => 'checkbox',
            'std' => ''
        ),
array(
            'name' => 'Add any YouTube video to this post',
            'desc' => 'Enter your chosen watch?v= code from YouTube',
            'id' => $prefix . 'video',
            'type' => 'text',
            'std' => ''
        ),
	)
);

add_action('admin_menu', 'mytheme_add_box');

function mytheme_add_box() {
	global $meta_box;
	
	add_meta_box($meta_box['id'], $meta_box['title'], 'mytheme_show_box', $meta_box['page'], $meta_box['context'], $meta_box['priority']);
}

function mytheme_show_box() {
	global $meta_box, $post;

	echo '<input type="hidden" name="mytheme_meta_box_nonce" value="', wp_create_nonce(basename(__FILE__)), '" />';
	
	echo '<table class="form-table">';

	foreach ($meta_box['fields'] as $field) {
		$meta = get_post_meta($post->ID, $field['id'], true);
		
		echo '<tr>',
				'<th style="width:20%"><label for="', $field['id'], '">', $field['name'], '</label></th>',
				'<td>';
		switch ($field['type']) {
			case 'text':
				echo '<input type="text" name="', $field['id'], '" id="', $field['id'], '" value="', $meta ? $meta : $field['std'], '" size="30" style="width:97%" />',
					'<br />', $field['desc'];
				break;
			case 'textarea':
				echo '<textarea name="', $field['id'], '" id="', $field['id'], '" cols="60" rows="4" style="width:97%">', $meta ? $meta : $field['std'], '</textarea>',
					'<br />', $field['desc'];
				break;
			case 'select':
				echo '<select name="', $field['id'], '" id="', $field['id'], '">';
				foreach ($field['options'] as $option) {
					echo '<option', $meta == $option ? ' selected="selected"' : '', '>', $option, '</option>';
				}
				echo '</select>';
				break;
			case 'radio':
				foreach ($field['options'] as $option) {
					echo '<input type="radio" name="', $field['id'], '" value="', $option['value'], '"', $meta == $option['value'] ? ' checked="checked"' : '', ' />', $option['name'];
				}
				break;
			case 'checkbox':
				echo '<input type="checkbox" name="', $field['id'], '" id="', $field['id'], '"', $meta ? ' checked="checked"' : '', ' />';
				break;
		}
		echo 	'<td>',
			'</tr>';
	}
	
	echo '</table>';
}

add_action('save_post', 'mytheme_save_data');

function mytheme_save_data($post_id) {
	global $meta_box;

	if (!wp_verify_nonce($_POST['mytheme_meta_box_nonce'], basename(__FILE__))) {
		return $post_id;
	}

	if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
		return $post_id;
	}

	if ('page' == $_POST['post_type']) {
		if (!current_user_can('edit_page', $post_id)) {
			return $post_id;
		}
	} elseif (!current_user_can('edit_post', $post_id)) {
		return $post_id;
	}
	
	foreach ($meta_box['fields'] as $field) {
		$old = get_post_meta($post_id, $field['id'], true);
		$new = $_POST[$field['id']];
		
		if ($new && $new != $old) {
			update_post_meta($post_id, $field['id'], $new);
		} elseif ('' == $new && $old) {
			delete_post_meta($post_id, $field['id'], $old);
		}
	}
}



		
// Display the sitename
	
function sitename () { ?>
	<?php $customlogo_options = get_option('theme_customlogo_options'); ?>
    <?php if ( $customlogo_options['logo'] != '' ) { ?>
        <div class="widescreen">
	        <a href="<?php echo home_url(); ?>"><img src="<?php echo $customlogo_options['logo']; ?>" alt="logo" class="logo" /></a>
        </div>
        <div class="nowidescreen">
	        <center>
		        <a href="<?php echo home_url(); ?>"><img src="<?php echo $customlogo_options['logo']; ?>" alt="logo" class="logo" /></a>
	        </center>
        </div>
    <?php } else { ?>
	    <?php if ( $sitename = get_option('mediafap_sitename') ) { ?>
		    <h1 class="sitename"><a href="<?php echo home_url(); ?>"><?php $sitename = get_option('mediafap_sitename'); echo stripslashes($sitename); ?></a></h1>
	    <?php } else { ?>
		    <div class="static">
			    <h1 class="sitename"><a href="<?php echo home_url(); ?>"><?php echo get_bloginfo('name'); ?></a></h1>
    		</div>
    		<div class="mobile">
    			<center>
    				<h1 class="sitename"><a href="<?php echo home_url(); ?>"><?php echo get_bloginfo('name'); ?></a></h1>
    			</center>
    		</div>
    	<?php } ?>
    <?php } ?>
<?php }
		
		
		
		
// Menu functions

function mainmenu() { ?>
    <div class="static">	
    	<div id="menucontainer">
    		<?php wp_nav_menu( array('menu_class' => 'mainmenu', 'menu_id' => '', 'container_class' => 'mainmenu', 'theme_location' => 'main_menu', 'depth' => '4', 'fallback_cb' => 'wp_page_menu' )); ?>
    	</div>
    </div>
    <div class="mobile">
    	<div class="smartmenu">
    		<form action="<?php echo home_url(); ?>/" method="get" class="dropit">
    			<div>
    				<?php
    					$select = wp_dropdown_categories('show_option_none=NAVIGATION&show_count=1&orderby=name&echo=0');
    					$select = preg_replace("#<select([^>]*)>#", "<select$1 onchange='return this.form.submit()'>", $select);
    					echo $select;
    				?>
    				<noscript><div><input type="submit" value="View" /></div></noscript>
    			</div>
    		</form>
    	</div>
    </div>
<?php }



	
// Display pagination links
		
function paginationlinks() { ?>
	<?php
		echo '<div class="paginationblock">'; 
		   pagination($pages = '', $range = 1);
	   echo '</div>';
	 ?>
<?php }




// Exclude pages from search results

function SearchFilter($query) {
	if ($query->is_search) {
		$query->set('post_type', 'post');
	}
		return $query;
	}
	add_filter('pre_get_posts','SearchFilter');




// Date format selector

function dateformat() { ?>
	<?php if ( get_option( 'mediafap_dateformat' ) == "EU") { ?>
		<?php if (function_exists('wp_days_ago')) { ?>
			<?php wp_days_ago(); ?>
		<?php } else { ?>
			<?php the_time('jS F, Y'); ?>
		<?php } ?>
	<?php } else { ?>
		<?php if (function_exists('wp_days_ago')) { ?>
			<?php wp_days_ago(); ?>
		<?php } else { ?>
			<?php the_time('F jS, Y'); ?>
		<?php } ?>
	<?php } ?>
<?php }
		
		
		

// Commenting system selector
		
function commenting() { ?>
    <div class="novertical">
        <?php if ( get_option( 'mediafap_selectcomments' ) == "None") { ?>
        <?php } else { ?>
            <?php if ( get_option( 'mediafap_selectcomments' ) == "Disqus") { ?>
                <div class="widget_comment">
                    <h4><?php _e( 'Readers Comments', 'mediafap' ); ?></h4>
                    <div class="widget_pad">
                        <?php $selectcommentsdisqus = get_option('mediafap_selectcommentsdisqus'); echo stripslashes($selectcommentsdisqus); ?>
                    </div>
                </div>
            <?php } else { ?>
                <?php if ( get_option( 'mediafap_selectcomments' ) == "Wordpress") { ?>
                    <div class="widget_comment">
                        <h4><?php _e( 'Readers Comments', 'mediafap' ); ?></h4>
                        <div class="widget_pad">
                            <?php comments_template( '', true ); ?>
                        </div>
                    </div>
                <?php } else { ?>
                <?php } ?>
            <?php } ?>
        <?php } ?>
    </div>
<?php }




// Floating social bar 

function floatingsocial() { ?>

	<?php if ( get_option( 'mediafap_floatingsocial' ) == "Enable") { ?>
    <div class="nomobile">
        <script type="text/javascript">stLight.options({publisher: "ur-c9128593-e43a-f53a-ce29-12c3943e4220", doNotHash: true, doNotCopy: true, hashAddressBar: false});</script>
<script>
var options={ "publisher": "ur-c9128593-e43a-f53a-ce29-12c3943e4220", "position": "left", "ad": { "visible": false, "openDelay": 5, "closeDelay": 0}, "chicklets": { "items": ["facebook", "twitter", "linkedin", "googleplus", "pinterest"]}};
var st_hover_widget = new sharethis.widgets.hoverbuttons(options);
</script>
</div>
	<?php } else { ?>
	<?php } ?>
<?php }




// Scrolling news tickertape

function scrollingticker () { ?>
	<div id="ticker">            
		<div class="ticker_float">
			<?php _e( 'LATEST', 'mediafap' ); ?>
		</div>
		<div class="marquee" id="mycrawler">
			<?php $my_query = new WP_Query('showposts=50&offset=0'); ?>
			<?php while ($my_query->have_posts()) : $my_query->the_post(); ?>
				<a href="<?php the_permalink(); ?>"><?php the_title(); ?></a>
				&nbsp; &nbsp; &nbsp; &middot; &nbsp; &nbsp; &nbsp;
			<?php endwhile; ?>
		</div>
		<script type="text/javascript">
			marqueeInit({
				uniqueid: 'mycrawler',
				style: {
					'width': '582px',
					'border': '0px'
				},
				inc: 1,
				mouse: 'pause',
				moveatleast: 1,
				neutral: 400,
				savedirection: true
			});
		</script>
	</div>
<?php } 




// Display advertisement placements
		
function bannertop() { ?>
        <?php if ( $bannertop = get_option('mediafap_bannertop') ) { ?>
        	<div class="header_pad">
				<center>
					<?php $bannertop = get_option('mediafap_bannertop'); echo stripslashes($bannertop); ?>
				</center>
            </div>
        <?php } else { ?>
        <?php } ?>
	<?php }





// Display analytics code
		
function analytics() { ?>	
	<?php if ( $analytics = get_option('mediafap_analytics') ) { ?>
		<?php $analytics = get_option('mediafap_analytics'); echo stripslashes($analytics); ?>
	<?php } else { ?>
	<?php } ?>
<?php }
		
		
		
		
// Display copyright text
		
function copyrighttext() { ?>		
	<?php if ( $copyright = get_option('mediafap_copyright') ) { ?>
		<?php $copyright = get_option('mediafap_copyright'); echo stripslashes($copyright); ?>
	<?php } else { ?>
		&nbsp;
	<?php } ?>  
<?php }




// Display the back to top button

function backtotop() { ?>
	<?php if ( get_option( 'mediafap_backtop' ) == "Enable") { ?>
	<div id="backtotop">
		<a href="#">
			<img src="<?php bloginfo('template_directory'); ?>/images/mediafap_up.png" class="backtop" alt="backtotop" />
		</a>
	</div>
	<?php } else { ?>
	<?php } ?>
<?php }




// Display social icons on posts

function socialposticons() { ?>
    <div class="novertical">
    	<?php if ( get_option( 'mediafap_postsocialselector' ) == "Enable") { ?>
    		<div class="widget">
    			<h4><?php _e( 'Socialise With Us', 'mediafap' ); ?></h4>
    			<div class="clearbigfix"></div>
    			<span class='st_facebook_hcount' displayText='Facebook'></span>
    			<span class='st_twitter_hcount' displayText='Tweet'></span>
    			<span class='st_linkedin_hcount' displayText='LinkedIn'></span>
    			<span class='st_pinterest_hcount' displayText='Pinterest'></span>
    		</div>
		<?php } else { ?>
    		<div class="clearbigfix"></div>
    	<?php } ?>
    </div>
<?php }




// WIDGET: Banner Advertisement

class bannerad extends WP_Widget {
	function bannerad() {
		$widget_ops = array(
			'classname' => 'widget_bannerad',
			'description' => 'Place a banner advertisement in the sidebar.'
		);
		$this->WP_Widget(
			'bannerad',
			'Advertisement',
			$widget_ops
		);
	}
	function widget( $args, $instance ) {
		extract($args);
		$title = apply_filters( 'widget_title', empty($instance['title']) ? '' : $instance['title'], $instance );
		$text = apply_filters( 'widget_execphp', $instance['text'], $instance );
		echo '<div class="widget_banner">';
	?>

					<center>
					<?php echo $instance['filter'] ? wpautop($text) : $text; ?>
                    </center>
	<?php
		echo '</div>';
	?>
	<?php
	}
	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		if ( current_user_can('unfiltered_html') )
			$instance['text'] =  $new_instance['text'];
		else
			$instance['text'] = stripslashes( wp_filter_post_kses( $new_instance['text'] ) );
			$instance['filter'] = isset($new_instance['filter']);
			return $instance;
		}
		function form( $instance ) {
			$instance = wp_parse_args( (array) $instance, array( 'title' => '', 'text' => '' ) );
			$title = strip_tags($instance['title']);
			$text = format_to_edit($instance['text']);
	?>
	<p>
		<label for="<?php echo $this->get_field_id("text"); ?>">
			<?php _e( 'Banner Code:', 'mediafap' ); ?>
			<textarea class="widefat" rows="10" cols="20" id="<?php echo $this->get_field_id('text'); ?>" name="<?php echo $this->get_field_name('text'); ?>">
				<?php echo $text; ?>
            </textarea>
		</label>
	</p>
	<p><?php _e( 'Enter your banner advertisement code, use 300*250px advertisements.', 'mediafap'); ?></p>
	<hr />
	<?php
		}
	}
	add_action('widgets_init', create_function('', 'return register_widget("bannerad");'));




// WIDGET: Post List

class postlist extends WP_Widget {
	function postlist() {
		$widget_ops = array(
			'classname' => 'widget_postlist',
			'description' => 'List posts from any or all of your categories.'
		);
		$this->WP_Widget(
			'postlist',
			'Post List',
			$widget_ops
		);
	}
	function widget($args, $instance) {
		global $post;
		$post_old = $post; 
		extract( $args );
		if( !$instance["title"] ) {
			$category_info = get_category($instance["cat"]);
			$instance["title"] = $category_info->name;
		}
		echo $before_widget;
		echo $before_title;
		if( $instance["title"] ) 
			echo '<a href="' . get_category_link($instance["cat"]) . '">' . $instance["title"] . '</a>';
		else
			echo '<a href="' . get_category_link($instance["cat"]) . '">' . $instance["cat"] . '</a>';
		echo $after_title;
	?>
	<?php if( $instance["thumbs"] ) { ?>
			<?php if( $instance["allcats"] ) { ?>
				<?php $my_query = new WP_Query("showposts=" . $instance["show"] . "&offset=" . $instance["skip"]); ?>
			<?php } else { ?>
				<?php $my_query = new WP_Query("showposts=" . $instance["show"] . "&cat=" . $instance["cat"] . "&offset=" . $instance["skip"]); ?>
			<?php } ?>
			<?php while ($my_query->have_posts()) : $my_query->the_post(); ?>
            <div class="widget_style">
				<a href="<?php the_permalink(); ?>">
					<?php the_post_thumbnail( 'img_80', array( 'class' => 'img_80', 'title' => '' ) ); ?>
				</a>
				<a href="<?php the_permalink(); ?>" title="<?php the_title(); ?>"><?php the_title(); ?></a>
			</div>
			<?php endwhile; ?>
	<?php } else { ?>
		<ul>
			<?php if( $instance["allcats"] ) { ?>
				<?php $my_query = new WP_Query("showposts=" . $instance["show"] . "&offset=" . $instance["skip"]); ?>
			<?php } else { ?>
				<?php $my_query = new WP_Query("showposts=" . $instance["show"] . "&cat=" . $instance["cat"] . "&offset=" . $instance["skip"]); ?>
			<?php } ?>
			<?php while ($my_query->have_posts()) : $my_query->the_post(); ?>
				<li><a href="<?php the_permalink(); ?>" title="<?php the_title(); ?>"><?php the_title(); ?></a></li>
			<?php endwhile; ?>
		</ul>
	<?php } ?>
	<?php
		echo $after_widget;
		$post = $post_old; 
	}
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
	function form($instance) {
	?>
	<p>
		<label for="<?php echo $this->get_field_id("title"); ?>">
			<?php _e( 'Title:' ); ?>
			<input class="widefat" id="<?php echo $this->get_field_id("title"); ?>" name="<?php echo $this->get_field_name("title"); ?>" type="text" value="<?php echo esc_attr($instance["title"]); ?>" />
		</label>
	</p>
	<p><?php _e( 'Give this widget a title, or leave blank to display the category name.', 'mediafap'); ?></p>
	<hr />
	<p>
		<label for="<?php echo $this->get_field_id("cat"); ?>">
			<?php _e( 'Category: &nbsp;' ); ?>		
			<?php wp_dropdown_categories( array( 'name' => $this->get_field_name("cat"), 'selected' => $instance["cat"] ) ); ?>
		</label>
	</p>
	<p><?php _e( 'Select a specific category to pull posts from.', 'mediafap'); ?></p>
	<hr />
	<p>
		<label for="<?php echo $this->get_field_id("allcats"); ?>">
			<?php _e( 'All Categories? &nbsp;' ); ?>
			<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id("allcats"); ?>" name="<?php echo $this->get_field_name("allcats"); ?>"<?php checked( (bool) $instance["allcats"], true ); ?> />
		</label>
	</p>
	<p><?php _e( 'Check the box to pull posts from all categories instead, overriding the above setting.', 'mediafap'); ?></p>
	<hr />
	<p>
		<label for="<?php echo $this->get_field_id("show"); ?>">
			<?php _e( 'Show X Posts: &nbsp;' ); ?>
			<input style="text-align: center;" id="<?php echo $this->get_field_id("show"); ?>" name="<?php echo $this->get_field_name("show"); ?>" type="text" value="<?php echo absint($instance["show"]); ?>" size='3' />
		</label>
	</p>
	<p><?php _e( 'Enter how many posts to display in this list (numerical).', 'mediafap'); ?></p>
	<hr />
	<p>
		<label for="<?php echo $this->get_field_id("skip"); ?>">
			<?php _e( 'Skip X Posts: &nbsp;' ); ?>
<input style="text-align: center;" id="<?php echo $this->get_field_id("skip"); ?>" name="<?php echo $this->get_field_name("skip"); ?>" type="text" value="<?php echo absint($instance["skip"]); ?>" size='3' />
		</label>
	</p>
	<p><?php _e( 'Enter how many posts to skip before starting the list (numerical).', 'mediafap'); ?></p>
	<hr />
	<p>
		<label for="<?php echo $this->get_field_id("thumbs"); ?>">
			<?php _e( 'Show Thumbnails? &nbsp;' ); ?>
			<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id("thumbs"); ?>" name="<?php echo $this->get_field_name("thumbs"); ?>"<?php checked( (bool) $instance["thumbs"], true ); ?> />
		</label>
	</p>
	<p><?php _e( 'Check the box to display thumbnail images.', 'mediafap'); ?></p>
	<hr />
	<?php
		}
	}
	add_action( 'widgets_init', create_function('', 'return register_widget("postlist");') );




// WIDGET: Featured Post

class featuredpost extends WP_Widget {
	function featuredpost() {
		$widget_ops = array(
			'classname' => 'widget_featuredpost',
			'description' => 'Feature any of your posts from any category with a large thumbnail image.'
		);
		$this->WP_Widget(
			'featuredpost',
			'Featured Post',
			$widget_ops
		);
	}
	function widget($args, $instance) {
		global $post;
		$post_old = $post; 
		extract( $args );
		if( !$instance["title"] ) {
			$category_info = get_category($instance["cat"]);
			$instance["title"] = $category_info->name;
		}
		echo $before_widget;
		echo $before_title;
		if( $instance["title"] ) 
			echo '<a href="' . get_category_link($instance["cat"]) . '">' . $instance["title"] . '</a>';
		else
			echo '<a href="' . get_category_link($instance["cat"]) . '">' . $instance["cat"] . '</a>';
		echo $after_title;
	?>
		<?php if( $instance["allcats"] ) { ?>
			<?php $my_query = new WP_Query("showposts=1&offset=" . $instance["skip"]); ?>
		<?php } else { ?>
			<?php $my_query = new WP_Query("showposts=1&cat=" . $instance["cat"] . "&offset=" . $instance["skip"]); ?>
		<?php } ?>
		<?php while ($my_query->have_posts()) : $my_query->the_post(); ?>
            <a href="<?php the_permalink(); ?>">
                <?php the_post_thumbnail( 'img_290', array( 'class' => 'img_290', 'title' => '' ) ); // POST IMAGE ?>
            </a>
            <div class="clear"></div>
            <h3 class="hometitle"><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h3>

		<?php endwhile; ?>

	<?php
		echo $after_widget;
		$post = $post_old; 
	}
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
	function form($instance) {
	?>
	<p>
		<label for="<?php echo $this->get_field_id("title"); ?>">
			<?php _e( 'Title:' ); ?>
			<input class="widefat" id="<?php echo $this->get_field_id("title"); ?>" name="<?php echo $this->get_field_name("title"); ?>" type="text" value="<?php echo esc_attr($instance["title"]); ?>" />
		</label>
	</p>
	<p><?php _e( 'Give this widget a title, or leave blank to display the category name.', 'mediafap'); ?></p>
	<hr />
	<p>
		<label for="<?php echo $this->get_field_id("cat"); ?>">
			<?php _e( 'Category: &nbsp;' ); ?>		
			<?php wp_dropdown_categories( array( 'name' => $this->get_field_name("cat"), 'selected' => $instance["cat"] ) ); ?>
		</label>
	</p>
	<p><?php _e( 'Select a specific category to pull posts from.', 'mediafap'); ?></p>
	<hr />
	<p>
		<label for="<?php echo $this->get_field_id("allcats"); ?>">
			<?php _e( 'All Categories? &nbsp;' ); ?>
			<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id("allcats"); ?>" name="<?php echo $this->get_field_name("allcats"); ?>"<?php checked( (bool) $instance["allcats"], true ); ?> />
		</label>
	</p>
	<p><?php _e( 'Check the box to pull posts from all categories instead, overriding the above setting.', 'mediafap'); ?></p>
	<hr />
	<p>
		<label for="<?php echo $this->get_field_id("skip"); ?>">
			<?php _e( 'Skip X Posts: &nbsp;' ); ?>
<input style="text-align: center;" id="<?php echo $this->get_field_id("skip"); ?>" name="<?php echo $this->get_field_name("skip"); ?>" type="text" value="<?php echo absint($instance["skip"]); ?>" size='3' />
		</label>
	</p>
	<p><?php _e( 'Enter how many posts to skip before starting the list (numerical).', 'mediafap'); ?></p>
	<hr />
	<?php
		}
	}
	add_action( 'widgets_init', create_function('', 'return register_widget("featuredpost");') );




// WIDGET: YouTube Embed

class youtubeembed extends WP_Widget {
	function youtubeembed() {
		$widget_ops = array(
			'classname' => 'widget_youtubeembed',
			'description' => 'Embed any YouTube video.'
		);
		$this->WP_Widget('youtubeembed', 'YouTube Embed', $widget_ops);
	}
	function widget($args, $instance) {
		global $post;
		$post_old = $post; 
		extract( $args );
		if( !$instance["title"] ) {
			$category_info = get_category($instance["cat"]);
			$instance["title"] = $category_info->name;
		}
		echo $before_widget;
		echo $before_title;
		if( $instance["title"] ) 
			echo $instance["title"];
		else
		echo 'Featured Video';
		echo $after_title;
	?>
		<?php if( isset( $instance["youtubeid"] ) ) { ?>
			<div class="widget_image">
				<iframe width="300" height="250" src="http://www.youtube.com/embed/<?php echo $instance["youtubeid"]; ?>" frameborder="0" allowfullscreen></iframe>
			</div>
		<?php } else { ?>
			<p><b>Error:</b> No video to show, check the ID you entered is correct.</p>
		<?php } ?>
	<?php
		echo $after_widget;
		$post = $post_old; 
		}
		function update($new_instance, $old_instance) {
			return $new_instance;
		}
		function form($instance) {
	?>
    <p>
		<label for="<?php echo $this->get_field_id("title"); ?>">
			<?php _e( 'Title:' ); ?>
			<input class="widefat" id="<?php echo $this->get_field_id("title"); ?>" name="<?php echo $this->get_field_name("title"); ?>" type="text" value="<?php echo esc_attr($instance["title"]); ?>" />
		</label>
	</p>
	<p><?php _e( 'Give this widget a title, or leave blank to display default text.', 'mediafap'); ?></p>
	<hr />
	<p>
		<label for="<?php echo $this->get_field_id("youtubeid"); ?>">
			<b><?php _e( 'watch?v= &nbsp;' ); ?></b>
			<input class="widefat" id="<?php echo $this->get_field_id("youtubeid"); ?>" name="<?php echo $this->get_field_name("youtubeid"); ?>" type="text" value="<?php echo esc_attr($instance["youtubeid"]); ?>" />
		</label>
	</p>
	<p><?php _e( 'Enter the watch?v= ID code of any YouTube video.', 'mediafap'); ?></p>
	<hr />
	<?php
		}
	}
	add_action( 'widgets_init', create_function('', 'return register_widget("youtubeembed");') );